Draft PointArray: Difference between revisions

From FreeCAD Documentation
(Updated Usage)
No edit summary
Line 47: Line 47:
# Optionally change the [[#Properties|properties]] of the array in the [[property_editor|Property editor]].
# Optionally change the [[#Properties|properties]] of the array in the [[property_editor|Property editor]].


== Point compound == <!--T:24-->
==Point compound==


<!--T:18-->
<!--T:18-->
Line 62: Line 62:
A Draft PointArray object is derived from a [[Part_Feature|Part Feature]] object and inherits all its properties (with the exception of some View properties that are not inherited by Link arrays). The following properties are additional unless otherwise stated:
A Draft PointArray object is derived from a [[Part_Feature|Part Feature]] object and inherits all its properties (with the exception of some View properties that are not inherited by Link arrays). The following properties are additional unless otherwise stated:


=== Data ===
===Data===


{{TitleProperty|Link}}
{{TitleProperty|Link}}
Line 89: Line 89:
* {{PropertyData|Point Object|Link}}: specifies the compound object whose points are used to position the elements in the array. The object must have a {{PropertyData|Links}}, {{PropertyData|Components}} or {{PropertyData|Geometry}} property, and contain at least one element with {{PropertyData|X}}, {{PropertyData|Y}}, and {{PropertyData|Z}} properties.
* {{PropertyData|Point Object|Link}}: specifies the compound object whose points are used to position the elements in the array. The object must have a {{PropertyData|Links}}, {{PropertyData|Components}} or {{PropertyData|Geometry}} property, and contain at least one element with {{PropertyData|X}}, {{PropertyData|Y}}, and {{PropertyData|Z}} properties.


=== View ===
===View===


{{TitleProperty|Link}}
{{TitleProperty|Link}}

Revision as of 09:52, 14 June 2021

This documentation is a work in progress. Please don't mark it as translatable since it will change in the next hours and days.

Draft PointArray

Menu location
Modification → Array tools → Point array
Workbenches
Draft, Arch
Default shortcut
None
Introduced in version
0.18
See also
Draft OrthoArray, Draft PolarArray, Draft CircularArray, Draft PathArray, Draft PathLinkArray, Draft PointLinkArray, Draft Clone

Description

The Draft PointArray tool places copies of a selected shape along various selected points.

The PointArray tool can be used on any object that has a Part TopoShape, meaning 2D shapes created with the Draft Workbench, but also 3D solids created with other workbenches, for example, Part, PartDesign, or Arch.

Object arranged at specific points

Usage

  1. Select the object you wish to array.
  2. Add the point compound object to the selection.
  3. There are several ways to invoke the command:
    • Press the Draft PointArray button.
    • Select the Modification → Array tools → Point array option from the menu.
  4. The array is created.
  5. Optionally change the properties of the array in the Property editor.

Point compound

A point compound is an object that contains one or more points. These are the supported point compounds and how they can be created:

Properties

See also: Property editor.

A Draft PointArray object is derived from a Part Feature object and inherits all its properties (with the exception of some View properties that are not inherited by Link arrays). The following properties are additional unless otherwise stated:

Data

Link

The properties in this group are only available for Link arrays. See Std LinkMake for more information.

  • DataScale (Float)
  • Data (Hidden)Scale Vector (Vector)
  • DataScale List (VectorList)
  • Data (Hidden)Visibility List (BoolList)
  • Data (Hidden)Placement List (PlacementList)
  • Data (Hidden)Element List (LinkList)
  • Data (Hidden)_ Link Touched (Bool)
  • Data (Hidden)_ Child Cache (LinkList)
  • Data (Hidden)Colored Elements (LinkSubHidden)
  • DataLink Transform (Bool)

Objects

  • DataBase (Link): specifies the object to duplicate in the array.
  • DataCount (Integer): (read-only) specifies the number of elements in the array. This number is determined by the number of points in the DataPoint Object.
  • DataExpand Array (Bool): specifies whether to expand the array in the Tree view to enable the selection of its individual elements. Only available for Link arrays.
  • DataExtra Placement (Placement): : specifies an additional placement, translation and rotation, for each element in the array. introduced in version 0.19
  • DataPoint Object (Link): specifies the compound object whose points are used to position the elements in the array. The object must have a DataLinks, DataComponents or DataGeometry property, and contain at least one element with DataX, DataY, and DataZ properties.

View

Link

The properties in this group, with the exception of the inherited property, are only available for Link arrays. See Std LinkMake for more information.

  • ViewDraw Style (Enumeration)
  • ViewLine Width (FloatConstraint)
  • ViewOverride Material (Bool)
  • ViewPoint Size (FloatConstraint)
  • ViewSelectable (Bool): this is an inherited property that appears in the Selection group for other arrays
  • ViewShape Material (Material)

Base

The properties in this group, with the exception of the inherited property, are only available for Link arrays. See Std LinkMake for more information.

  • View (Hidden)Child View Provider (PersistentObject)
  • View (Hidden)Material List (MaterialList)
  • View (Hidden)Override Color List (ColorList)
  • View (Hidden)Override Material List (BoolList)
  • View (Hidden)Proxy (PythonObject): this is an inherited property.

Display Options

The properties in this group are inherited properties. See Part Feature for more information.

  • ViewBounding Box (Bool): this property is not inherited by Link arrays.
  • ViewDisplay Mode (Enumeration): for Link arrays it can be Link or ChildView. For other arrays it can be: Flat Lines, Shaded, Wireframe or Points
  • ViewShow In Tree (Bool)
  • ViewVisibility (Bool)

Draft

  • ViewPattern (Enumeration): not used.
  • ViewPattern Size (Float): not used.

Object style

The properties in this group are not inherited by Link arrays.

Scripting

See also: Autogenerated API documentation and FreeCAD Scripting Basics.

To create a point array use the make_point_array method (introduced in version 0.19) of the Draft module. This method replaces the deprecated makePointArray method.

point_array = make_point_array(base_object, point_object, extra=None, use_link=True)
  • base_object is the object to be arrayed. It can also be the Label (string) of an object in the current document.
  • point_object is the object containing the points. It can also be the Label (string) of an object in the current document. It should have a Geometry, Links, or Components property containing points.
  • extra is an App.Placement, an App.Vector or an App.Rotation that displaces each element.
  • If use_link is True the created elements are App Links instead of regular copies.

Example:

import FreeCAD as App
import Draft

doc = App.newDocument()

polygon = Draft.make_polygon(3, radius=500.0)

p1 = Draft.make_point(App.Vector(1500, 0, 0))
p2 = Draft.make_point(App.Vector(2500, 0, 0))
p3 = Draft.make_point(App.Vector(2000, 1000, 0))

compound = doc.addObject("Part::Compound", "Compound")
compound.Links = [p1, p2, p3]

point_array = Draft.make_point_array(polygon, compound)
doc.recompute()